<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Entities;

use Zeedhi\DevOps\Model\Projectmanagement\EntitiesInterface\Calendar\EntityCalendarUserInterface;
use Zeedhi\DevOps\Util\Events\Audit_with_id\AuditAble;
use Zeedhi\DevOps\Util\Events\Organization_with_id\OrganizationAble;


class Structure extends \Zeedhi\DevOps\Model\Projectmanagement\Entities\Base\Structure
    implements
    AuditAble,
    OrganizationAble,
    \Zeedhi\DevOps\Model\Util\LogicalDeleted,
    EntityCalendarUserInterface{

    const IS_ACTIVE = 'A';

    /**
     * @return boolean
     */
    public function isLogicalDeleted()
    {
        return $this->getStatus() == self::STATUS_LOGICAL_DELETED;
    }


    public function getAllCalendar() {
        return $this->getParentsCalendar();
    }

    public function getParentsCalendar()
    {
        $calendar = array($this->getCalendar());
        if ($this->getParent()) {
            $calendar = array_merge($this->getParent()->getParentsCalendar(), $calendar);
        }

        return $calendar;
    }

    public function deleteEntity()
    {
        $this->setStatus(self::STATUS_LOGICAL_DELETED);
    }

}