import { Loader, Metadata, Singleton } from '@zeedhi/core';
import { IGridEvent, Tabs } from '@zeedhi/common';
import Store from '@/store';
import { AclLabelsLogGridController } from '@/controllers/AclLabels/AclLabelsLogGridController';

@Singleton
export class AclLabelsGridController {
	public currentProject: any = {};

	public projectName: string = '';

	get gridIsVisible() {
		return Store.getters['AclLabels/getGridIsVisible'];
	}

	public async rowClickAclLabelsProjectGrid({ row }: IGridEvent) {
		Store.commit('AclLabels/setCurrentProject', row);
		Store.commit('AclLabels/setGridIsVisible', false);
		await this.loadTabs(row);
	}

	private async loadTabs(row: any) {
		const tabs = Metadata.getInstance<Tabs>('aclLabelsProjectTabs');
		if (tabs.activeTab === 0) {
			await Store.dispatch('AclLabels/loadAclLabelsTreeComponent');
			await Store.dispatch('AclLabels/loadNodes', row.PROJECT_ID);
			Store.commit('AclLabels/setLogGridIsVisible', true);
		} else if (tabs.activeTab === 1) {
			const aclLabelsLogGridController: AclLabelsLogGridController = Loader.getInstance('AclLabelsLogGridController');
			await aclLabelsLogGridController.onClickTab();
		}
	}
}
